package lt.bit.draudimas.configuration;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.authentication.builders.AuthenticationManagerBuilder;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
import org.springframework.security.config.annotation.web.configuration.WebSecurityConfigurerAdapter;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.crypto.password.PasswordEncoder;


import lt.bit.draudimas.services.UserService;

@Configuration
@EnableWebSecurity
public class SecurityConfiguration extends WebSecurityConfigurerAdapter {

	@Autowired
	UserService userService;
	
	@Override
	protected void configure(AuthenticationManagerBuilder auth) throws Exception {
		auth
			.userDetailsService(userService)
			.passwordEncoder(passwordEncoder());
		
		
		/*
		auth
			.inMemoryAuthentication()
				.withUser("gediminas").password((new BCryptPasswordEncoder()).encode("user")).roles("user")
				.and()
				.withUser("admin").password((new BCryptPasswordEncoder()).encode("admin")).roles("user","admin");
		*/		
	}
	
	
	
	@Override
	protected void configure(HttpSecurity http) throws Exception {
		
		
		http
			.authorizeRequests()
				
			
				.anyRequest().permitAll()
		
		.and()
			.logout()
				.logoutUrl("/atsijungti")
				.logoutSuccessUrl("/login")
		.and()	
			.formLogin()
				.loginPage("/login")
				
				.failureUrl("/login-error");
		
			
	}



	@Bean
	public PasswordEncoder passwordEncoder() {
		return new BCryptPasswordEncoder();
	}
	

}
